include:
  - project: 'authoring/documentation/mkdocs-ci'
    file: 'mkdocs-gitlab-pages.gitlab-ci.yml'

variables:
  MKDOCS_MERGE_VERSION: '0.8.0'

stages:
  - mkdocs-merge
  - validation
  - pages

mkdocs-merge:
  image: registry.cern.ch/docker.io/library/python:3.9-slim-bullseye
  stage: mkdocs-merge
  interruptible: true
  before_script:
    - apt update && apt install -y git subversion
    - pip install --upgrade pip setuptools wheel
    - pip install mkdocs==${MKDOCS_VERSION} mkdocs-material==${MATERIAL_VERSION} mkdocs-merge==${MKDOCS_MERGE_VERSION}
  script:
    # Clone repositories
    # Make sure that users pushing to this repository have permissions to read (clone) each repository.
    # This is needed because the CI_JOB_TOKEN which is used to clone the repos, 
    # holds the same permissions as the user who triggered the initial job.
    # Example:
    # - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.example.com/<namespace>/<project>
    - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.cern.ch/authoring/documentation/mkdocs-example-1-multiple-repositories.git
    - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.cern.ch/authoring/documentation/mkdocs-example-2-multiple-repositories.git
    # Merge mkdocs content
    - mkdocs-merge run . mkdocs-example-1-multiple-repositories/ mkdocs-example-2-multiple-repositories/
  artifacts:
    paths:
      - mkdocs.yml
      - docs/
    expire_in: 1 hour
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      when: never
    - if: $CI_COMMIT_BRANCH || $CI_DEFAULT_BRANCH
      when: always
    - if: '$CI_PIPELINE_SOURCE == "pipeline"'
      when: always

validation:
  dependencies:
    - mkdocs-merge
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      when: never
    - if: $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH
      when: always
    - if: '$CI_PIPELINE_SOURCE == "pipeline"'
      when: always  

pages:
  dependencies:
    - mkdocs-merge
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: always
    - if: '$CI_PIPELINE_SOURCE == "pipeline"'
      when: always 
